PROBLEM LINK:Authors: Jaub Safin DIFFICULTY:Simple PREREQUISITES:Simple observations, dp PROBLEM:An array is called alternating if any two consecutive numbers in it have opposite signs (i.e. one of them should be negative, whereas the other should be positive). You are given an array $A$ of size $N$ consisting of nonzero elements. For each index $i$ from $1$ to $N$, you have to find the length of longest subarray starting at $i$. QUICK EXPLANATION:We can observe that if an array is alternating, then all of its subarrays are also alternating. So, we can divide the array into maximal alternating subarrays. For doing that, we will iterate over array from left to right, if the sign of current number is different than previous number, then this number can be used to extend previous alternating subarray, Otherwise we will have to start constructing a new maximal alternating subarray. In this way, we can partition the array into various maximal alternating subarrays. After this, finding length of longest subarray starting at index $i$ is quite easy, as it can be done easily by finding the position of $i$ in the corresponding maximal alternating subarray. If $p$ be position and $L$ be the length of the maximal subarray, then $L  p + 1$ will be the length of longest subarray starting at index $i$. EXPLANATION:Observation 1: So, we can change the array $A$ such that it consists of 1 and 1's only. Observation 2: Let us take an example to understand how we can apply the above observation to solve the problem. Now, we go to $A_2$, we can see that $A_2, A_3, A_4$ have different signs, and $A_4$ has same sign as $A_5$. So, we break the array into several parts such that each part is maximal alternating subarray. In our example, the parts will be We can formalize the above idea to write a pseudo code to break an array into various parts of maximal alternating subarrays.
Now, let us find the length of longest alternating subarray ending at each index $i$ for our example subarray $A$. So, this means that for an maximal alternating subarray of length $L$, the answers (length of longest alternating subarray start from that index) will be $L, L1, \dots, 1$. We can use this idea to solve our problem.
Dynamic programming based SolutionYou can also solve the problem by a very simple dp. Let $len[i]$ denote the maximum length of alternating subarray starting at position $i$.
Time Complexity:As we have seen in both the solutions we have to iterate over the array $A$ only once or constant number of times. So, time complexity of the algorithm will be $\mathcal{O}(N)$ which will easily fit in time with $N = 10^5$ and $T = 10$. AUTHOR'S AND TESTER'S SOLUTIONS:
This question is marked "community wiki".
asked 20 Mar '16, 17:34

My Approach: Everytime you find a subarray whose longest alternating count is greater than one, all you have to do is print it, and decrement and print it till it becomes one. Then skip the next count1 elements. answered 21 Mar '16, 00:18

CAn u provide us with ur test cases and corresponding answers pls.. since I am getting wrong answer . answered 21 Mar '16, 00:12

answered 21 Mar '16, 00:14

can tester tell me ur test cases and corresponding answers pls answered 21 Mar '16, 00:21
If your solution is wrong, then try generating subarrays of length <= 10 (with +1, 1) only and run against a correct solution. Also if you have some overflow bug due to not using long long at desired places, then for the same test cases, change $+1$ to $10^9$ and $1$ to $10^9$
(21 Mar '16, 07:56)
https://www.codechef.com/viewsolution/9712232 This is solution.. And not able to get any bugg
(21 Mar '16, 08:26)
Getting right answer for every sample input
(21 Mar '16, 08:28)

In the dp solution why do you write answered 21 Mar '16, 00:52
There is something wrong in your claims. Can you give links of both the solutions?
(21 Mar '16, 01:10)
https://www.codechef.com/viewsolution/9713110 < this is solution where a is long long int(WA) https://www.codechef.com/viewsolution/9713154 < this is the other one(AC) The Above solutions are similar to solution in editorial https://www.codechef.com/viewsolution/9711723 < This is the one I submitted during contest.(WA) https://www.codechef.com/viewsolution/9713715 < This is with a is long long int (WA) https://www.codechef.com/viewsolution/9713162 < This is the same submission with only one change as mentioned above in previous comment(i.e. including 1ll). (AC)
(21 Mar '16, 03:08)
@dpraveen did you see the solutions above? What do you think?
(21 Mar '16, 14:16)

https://www.codechef.com/viewsolution/9712232 This is link of my solution.. getting wrong answer continuously...Still i cant found any bugg.. Pls help me out answered 21 Mar '16, 08:06
Tried inputting many cases and getting every tym correct answer.Still i am getting WA in ur compiler
(21 Mar '16, 08:09)

Did exactly the same way which is mentioned in Quick Explanation. My Solution : https://www.codechef.com/viewsolution/9708007 answered 21 Mar '16, 08:46

is my program correct? someone pl tell https://www.codechef.com/viewsolution/9714935 answered 21 Mar '16, 14:24
someone plzzzz help!!
(21 Mar '16, 14:56)
You should not print anything other than output, So remove
(21 Mar '16, 17:29)
ok.i will take care of this now. Apart frm that d program is ok na?
(21 Mar '16, 19:05)
and thanks for helping
(21 Mar '16, 19:06)

Why u people dont tell ur testing test cases so that every one check why they are getting wrong answers.. answered 21 Mar '16, 18:20

Why u people dont tell ur testing test cases so that every one check why they are getting wrong answers.. answered 21 Mar '16, 18:21

@vineet1003 answered 22 Mar '16, 00:50

Please help>> answered 23 Mar '16, 13:37

Can someone help me with my program. I am getting Time Limit Exceeded error https://www.codechef.com/viewsolution/9739516 answered 26 Mar '16, 12:01

My program shows exactly the same output as shown in the problem but it still says "wrong answer" please help me where i am going wrong? here's the link to my code https://www.codechef.com/viewsolution/9755162 answered 27 Mar '16, 13:10

Can't spot mistake..getting WA :'( answered 27 Mar '16, 22:59

public static void main(String arg[]) { Scanner sc=new Scanner(System.in); int t=sc.nextInt(); int n; while(t>0) { n=sc.nextInt(); long[] a=new long[n]; for(int i=0;i<n;i++) {="" a[i]="sc.nextLong();" }="" int[]="" b="new" int[n];="" b[n1]="1;" for(int="" i="n2;i">=0;i) { if(a[i]*a[i+1]<0) b[i]=b[i+1]+1; else b[i]=1; } for(int x : b) System.out.printf("%d ",x); System.out.println(); t; } } } time limit is exceeding plz help answered 22 Apr '16, 15:35

https://www.codechef.com/viewsolution/9972627 this is my solution.it works fine with the test cases but its not getting accepted. pls help thanks in advance. answered 27 Apr '16, 15:50

I would like to thank you for the time you invest in making such nice post cause as I think it can be very helpful for many people who just wish to get as much information about this topic as possible. answered 29 Apr '16, 15:37

when i am running this code it is showing correct output, but when i am submitting it, it is showing wrong answer. Here is the link to my solution: https://www.codechef.com/viewsolution/10155565 answered 24 May '16, 20:36

include <stdio.h>int a[100002]; int sign(int); int dp(long long int, long long int,long long int); int main(void) { long long int n,t,i,x; scanf("%lld",&t); while(t) { scanf("%lld",&n); for(i=0;i<n;i++) scanf("%lld",&a[i]);
} int dp(long long int y,long long int s,long long int n) { if(y==n1) return 1;
} int sign(int n) { if(n>0) return 1;
} answered 01 Jun '16, 16:17

I am getting time limit exceeding but cant see my mistake , plz help import java.io.*; import java.math.*; import java.util.*; class subarrayprefix public static Long[] a=new Long[1000000];
} answered 10 Jun '16, 22:28

https://www.codechef.com/viewsolution/10533083 Can you check why am I getting a WA ? answered 19 Jun '16, 04:53

This problem can be easily solved using stacks. Here is my solution http://ideone.com/fork/WaJVs5 . If you find anything incorrect please let me know. answered 24 Jun '16, 10:24

include <iostream>include <stdio.h>include <algorithm>int main() {
} What is wrong in this code, Why is it showing Wrong Answer ! answered 20 Jul '16, 13:47

include <iostream>using namespace std; int main() { int t; cin>>t; while(t) { int n; cin>>n; string s; long long int x; int a[n]; for(int i=0;i<n;i++) {="" cin="">>x; if(x>0) s+='+'; else s+=''; a[i]=1; } //cout<<s<<endl; for(int="" i="1;i<n;i++)" {="" if(s[i]!="s[i1])" a[0]++;="" else="" break;="" }="" cout<<a[0]<<"="" ";="" for(int="" i="1;i<n;i++)" {="" if(a[i1]="">1) { a[i]=a[i1]1; } else for(int j=i+1;j<n;j++) { if(s[j]!=s[j1]) a[i]++; else break; } cout<<a[i]<<" "; } cout<<endl; } return 0; } answered 03 Aug '16, 15:33

I am wondering if you could solve that problem using a segment tree ? Anyone used that approach ? Would it be more efficient ? Thanks answered 20 Jun '17, 18:33

One question we can ask in an interview will be to how to treat 0's . answered 19 Jan '18, 23:26

check out a very simple solution here https://github.com/anjn98/codechef/blob/master/ALTARAY.cpp answered 04 Mar '18, 12:35

I want to know on which test case this stack implementation fails..help.. answered 01 Aug '18, 23:49

A simple pytonh DP approach utilising the fact that minimum length will be taken as 1 per index answered 03 Jan, 01:14

Why can't we do this?
answered 23 Jan, 22:02
